#include <windows.h>
#include <ddraw.h>
#include "Global.h"

bool DDInit()
{
	if(FAILED(DirectDrawCreate(NULL, &g_lpdd, NULL)))
	{
		MessageBox(g_hwnd, "DirectDrawCreate Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("DirectDrawCreate Failed");
		return false;	
	}

	if(FAILED(g_lpdd->QueryInterface(IID_IDirectDraw4, (LPVOID*)&g_pDDraw4)))
	{
		MessageBox(g_hwnd, "QueryInterface Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("QueryInterface Failed");
		return false;	
	}

	g_lpdd->Release();

	if(FAILED(g_pDDraw4->SetCooperativeLevel(g_hwnd, DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT | DDSCL_EXCLUSIVE)))
	{
		MessageBox(g_hwnd, "SetCooperativeLevel Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("SetCooperativeLevel Failed");
		return false;
	}

	if(FAILED(g_pDDraw4->SetDisplayMode(800, 600, SCREEN_BPP, 0, 0)))
	{
		MessageBox(g_hwnd, "SetDisplayMode Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("SetDisplayMode Failed");
		return false;
	}

	memset(&g_ddsd, 0, sizeof(g_ddsd));
	g_ddsd.dwSize = sizeof(g_ddsd);
	g_ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	g_ddsd.dwBackBufferCount = 1;
	g_ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_COMPLEX | DDSCAPS_FLIP;

	if(FAILED(g_pDDraw4->CreateSurface(&g_ddsd, &g_pPrimary, NULL)))
	{
		MessageBox(g_hwnd, "CreateSurface Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("CreateSurface Failed");
		return false;
	}

	g_ddsd.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER;

	if(FAILED(g_pPrimary->GetAttachedSurface(&g_ddsd.ddsCaps, &g_pBack)))
	{
		MessageBox(g_hwnd, "GetAttachedSurface Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("GetAttachedSurface Failed");
		return false;
	}	

	g_pTitleSurface = LoadGameBitmap("FinalTitle.bmp");

	return true;
}


void GameShutdown()
{
	if(g_pBack)
	{
		g_pBack->Release();
		g_pBack = 0;
	}

	if(g_pPrimary)
	{
		g_pPrimary->Release();
		g_pPrimary = 0;
	}

	if(g_pDDraw4)
	{
		g_pDDraw4->Release();
		g_pDDraw4 = 0;
	}
}

