#include <windows.h>
#include <ddraw.h>

// Defines
#define WIN32_LEAN_AND_MEAN
#define SCREEN_BPP 16
#define RGBVAL(r, g, b) ((b%32) + ((g%64) << 6) + ((r%32) << 11))

// Function Prototypes
LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
void LogInit();
void GameMain();
void GameShutdown();
bool DDInit();
void LogInit(void);
void Log(char Text[], int SetFlag = 1);
void Log(int Number, int SetFlag = 1);
void PlotPixel(int x, int y, unsigned short RGB, LPDIRECTDRAWSURFACE4 lpdds4);
void GetInput();
int FPSCounter();
void RenderScene();
void DisplayText(int x, int y, char* buffer, long color);
void Collision();
LPDIRECTDRAWSURFACE4 LoadGameBitmap(char *filename);

// Global Variables
extern HINSTANCE g_hInstance;   // Application Instance
extern HWND g_hwnd;   // Main window handle
extern LPDIRECTDRAW g_lpdd; // Direct Draw Object
extern LPDIRECTDRAW4 g_pDDraw4; // Direct Draw 4 Object
extern DDSURFACEDESC2 g_ddsd; // Surface description
extern LPDIRECTDRAWSURFACE4 g_pPrimary; // Primary Surface
extern LPDIRECTDRAWSURFACE4 g_pBack; // back buffer
extern LPDIRECTDRAWSURFACE4 g_pTitleSurface;

extern struct CGame Game;
extern struct CPaddle Player;
extern struct CPaddle Enemy;
extern struct CBall Ball;

// Global Class's
struct CPaddle
{
	CPaddle(int x1, int y1, int x2, int y2);

	void Update();
	
	USHORT color;
	int x1;
	int y1;
	int x2;
	int y2;
	RECT myRect;
};

struct CBall
{
	CBall();

	void Update();

	USHORT color;
	int Velx;
	int Vely;
	int x1;
	int y1;
	int x2;
	int y2;
	RECT myRect;
};

struct CGame
{
	long Score;
	bool lose;
	long lives;
	bool over;
	int level;
	bool win;
	bool showDebug;
};


