#include <fstream>
#include "Global.h"
using namespace std;

/*
	void LogInit(void);
	void Log(char Text[], int SetFlag);
	void Log(int Number, int SetFlag);
	void PlotPixel(int x, int y, unsigned short RGB, LPDIRECTDRAWSURFACE4 lpdds4);
	void DisplayText(int x, int y, char* buffer, USHORT color);
	LPDIRECTDRAWSURFACE4 LoadGameBitmap(char *filename)
*/

void LogInit(void)
{
	ofstream File("Log.txt"); // Trunc file
	if(!File)
	{
		MessageBox(NULL, "Could not open Log File.", "Error", MB_ICONSTOP);
		return;
	}
	File.close();
}


void Log(char Text[], int SetFlag) // Set flag defulted to 1
{
	char Flag = '\n';
	if(SetFlag == 0) Flag = ' ';

	ofstream File("Log.txt", ios::app);
	if(!File)
	{
		MessageBox(NULL, "Could not open Log File.", "Error", MB_ICONSTOP);
		return;
	}
	File << Text << Flag;
	File.close();
	return;
}

void Log(int Number, int SetFlag) // Set flag defulted to 1
{
	char Flag = '\n';
	if(SetFlag == 0) Flag = ' ';
	
	ofstream File("Log.txt", ios::app);
	if(!File)
	{
		MessageBox(NULL, "Could not open Log File.", "Error", MB_ICONSTOP);
		return;
	}
	File << Number << Flag;
	File.close();
	return;
}

void PlotPixel(int x, int y, unsigned short RGB, LPDIRECTDRAWSURFACE4 lpdds4)
{
	DDSURFACEDESC2 ddsd;
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);

	lpdds4->Lock(0, &ddsd, DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR, 0);

	USHORT *videoBuffer = (USHORT*)ddsd.lpSurface;
	videoBuffer[x+y*(ddsd.lPitch >> 1)] = RGB;

	lpdds4->Unlock(0);
}

void DisplayText(int x, int y, char* buffer, long color)
{
	HDC hdc;
	g_pBack->GetDC(&hdc);

	COLORREF oldfcol, oldbcol;
	oldfcol = SetTextColor(hdc, color);
	oldbcol = SetBkColor(hdc, 0xff00ff);
	int oldtmode = SetBkMode(hdc, TRANSPARENT);

	TextOut(hdc, x, y, buffer, strlen(buffer));

	SetTextColor(hdc, oldfcol);
	SetBkColor(hdc, oldbcol);
	SetBkMode(hdc, oldtmode);

	g_pBack->ReleaseDC(hdc);
}

// Macros
#define RGB16(red, green, blue) ( ((red >> 3) << 11) | ((green >> 2) << 5) | (blue >> 3)) 

LPDIRECTDRAWSURFACE4 LoadGameBitmap(char *filename)
{   
	BITMAPINFOHEADER infoheader;  
	DDSURFACEDESC2   surfaceDesc; 
	LPDIRECTDRAWSURFACE4 NewSurface;
	WORD             *bitmapData;  
	WORD             *bitmapDone;   
	FILE             *bitmapFile;   
	BYTE             red, green, blue; 
	
	bitmapFile = fopen(filename, "rb");
	fseek(bitmapFile, sizeof(BITMAPFILEHEADER), SEEK_SET);  
	fread(&infoheader, sizeof(BITMAPINFOHEADER), 1, bitmapFile); 
	
	ZeroMemory(&surfaceDesc, sizeof(surfaceDesc));  
	surfaceDesc.dwSize = sizeof(surfaceDesc);  
	surfaceDesc.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;  
	surfaceDesc.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;  
	surfaceDesc.dwWidth = infoheader.biWidth; 
	surfaceDesc.dwHeight = infoheader.biHeight;   

	if(FAILED(g_pDDraw4->CreateSurface(&surfaceDesc, &NewSurface, NULL)))
	{
		MessageBox(g_hwnd, "NewSurface Failed", "ERROR", MB_ICONSTOP | MB_OK);
		Log("NewSurface Failed");
		return false;
	}

	ZeroMemory(&surfaceDesc, sizeof(surfaceDesc));  
	surfaceDesc.dwSize = sizeof(surfaceDesc);  
	NewSurface->Lock(NULL, &surfaceDesc, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL); 
	bitmapData = new WORD[infoheader.biWidth * infoheader.biHeight];  
	bitmapDone = (WORD *)surfaceDesc.lpSurface;   
	for( int y=0; y<infoheader.biHeight; ++y)  
	{     
		for( int x=0; x<infoheader.biWidth; ++x)     
		{        
			fread(&blue, sizeof(BYTE), 1, bitmapFile);     
			fread(&green, sizeof(BYTE), 1, bitmapFile);        
			fread(&red, sizeof(BYTE), 1, bitmapFile);      
			bitmapData[y*infoheader.biWidth + x] = RGB16(red, green, blue);     
		}   
	}   
	
	int heightIndex = 0;	
	for( y=infoheader.biHeight-1;  y>=0; --y)   
	{      
		for( int x=0; x<infoheader.biWidth; ++x)         
			bitmapDone[heightIndex*(surfaceDesc.lPitch/2) + x] = bitmapData[y*infoheader.biWidth + x];       
			++heightIndex;   
	}   
	delete bitmapData;
	if(FAILED(NewSurface->Unlock(NULL))) MessageBox(g_hwnd, "hi", "rgfdgsdg", 0);  
	fclose(bitmapFile);
	return NewSurface;
}
























