#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "Global.h"
#include "resource.h"

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) 
{
	LogInit(); // Initialize log file
	g_hInstance = hInstance;

	WNDCLASSEX WndClass;
    HWND hwnd;
    MSG msg;

    WndClass.cbSize        = sizeof(WNDCLASSEX);
    WndClass.style         = NULL;
    WndClass.lpfnWndProc   = WndProc;
    WndClass.cbClsExtra    = 0;
    WndClass.cbWndExtra    = 0;
    WndClass.hInstance     = hInstance;
    WndClass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
    WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
    WndClass.hbrBackground = 0;//(HBRUSH)(BLACK_BRUSH);
    WndClass.lpszMenuName  = NULL;
    WndClass.lpszClassName = "WindowClass";
    WndClass.hIconSm       = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));

    if(!RegisterClassEx(&WndClass)) 
	{
		MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONSTOP | MB_OK);
		Log("Window Registration Failed!");
        return 0;
    }

    hwnd = CreateWindowEx(NULL, 
		                  "WindowClass", 
						  "Twisted Pong", 
						  WS_POPUP | WS_VISIBLE, 
						  0, 0, // x, y startup pos
						  1024, 768, // window size
						  NULL, NULL,
						  hInstance, // app instance
						  NULL);

    if(!hwnd) 
	{
        MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONSTOP | MB_OK);
		Log("Window Creation Failed!");
        return 0;
    }
	g_hwnd = hwnd;
	ShowCursor(FALSE);
	
	if(!DDInit()) // DirectX Init -> bool DDInit(void);
	{
		GameShutdown(); // Release anything created
		ShowCursor(TRUE);
		return 0;
	}

    while(TRUE) // Game Loop
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{

			if(msg.message == WM_QUIT) break; // Exit Game Loop

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		GameMain();
    }
	
	GameShutdown();

	ShowCursor(TRUE);

	Log("Game successfully returning..."); 
    return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch(Message) 
	{
    case WM_DESTROY:
        PostQuitMessage(0);
        break;

    default:
        return DefWindowProc(hwnd, Message, wParam, lParam);
    }
    return 0;
} 

